#include "c_character_actor.h"
#include <stdio.h>

c_character_actor::c_character_actor()
{
	m_speed  = 0;
	m_health = 0;
}

c_character_actor::c_character_actor(c_game *game, string dat_file):c_actor(game, "")
{
	FILE *f = fopen(dat_file.c_str(), "r");
	char buf[256];
	string anim_dat_file;
	
	m_speed  = 0;
	m_health = 0;
	if (f)
	{
		// Read animation data file name
		fscanf(f, "%255s", buf);
		anim_dat_file.assign(buf);
		
		// Load animation data file
		c_actor::load_dat_file(anim_dat_file);
		
		// Read player speed
		fscanf(f, "%f", &m_speed);
		
		fclose(f);
	}
}

c_character_actor::~c_character_actor()
{
}

void c_character_actor::set_speed(float speed)
{
	m_speed = speed;
}

float c_character_actor::get_speed(void)
{
	return m_speed;
}

void c_character_actor::set_health(float health)
{
	m_health = health;
}

float c_character_actor::get_health(void)
{
	return m_health;
}

bool c_character_actor::hit(float hit_power)
{
	m_health -= hit_power;
	
	// Return true if character is dead, false otherwise
	return (m_health <= 0.0);
}
