#include "c_powerup.h"

c_powerup::c_powerup(c_game *game, string dat_file, POWERUP_TYPE type, float value, int lifespan):c_actor(game, dat_file)
{
	m_type     = type;
	m_value    = value;
	m_lifespan = lifespan;
	m_f_active = true;
}

c_powerup::~c_powerup()
{
}

void c_powerup::draw(BITMAP *bmp_dest)
{
	// Use base c_actor::draw() to draw powerup.
	c_actor::draw(bmp_dest);
}

void c_powerup::update(void)
{
	if (!m_f_active)
		return;
	
	// Decrease lifespan and deactivate if it reaches 0
	m_lifespan--;
	if (m_lifespan <= 0)
		m_f_active = false;
	
	// Case c_actor::update()
	c_actor::update();
}

POWERUP_TYPE c_powerup::get_type(void)
{
	return m_type;
}

float c_powerup::get_value(void)
{
	return m_value;
}

bool c_powerup::is_active(void)
{
	return m_f_active;
}

void c_powerup::deactivate(void)
{
	m_f_active = false;
}
